'use strict';

var _babelCore = require('babel-core');

var _ = require('../');

var _2 = _interopRequireDefault(_);

var _babelPluginTransformEs2015Classes = require('babel-plugin-transform-es2015-classes');

var _babelPluginTransformEs2015Classes2 = _interopRequireDefault(_babelPluginTransformEs2015Classes);

var _babelPluginTransformReactJsx = require('babel-plugin-transform-react-jsx');

var _babelPluginTransformReactJsx2 = _interopRequireDefault(_babelPluginTransformReactJsx);

var _babelPluginTransformReactPug = require('babel-plugin-transform-react-pug');

var _babelPluginTransformReactPug2 = _interopRequireDefault(_babelPluginTransformReactPug);

var _babelPluginTransformEs2015BlockScoping = require('babel-plugin-transform-es2015-block-scoping');

var _babelPluginTransformEs2015BlockScoping2 = _interopRequireDefault(_babelPluginTransformEs2015BlockScoping);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

test('simple undeclared variable', function () {
  // counter example
  var opts = {
    babelrc: false,
    plugins: [_2.default]
  };
  var input = 'Promise.resolve(foo).then(console.log);';
  expect(function () {
    return (0, _babelCore.transform)(input, opts);
  }).toThrow(/Reference to undeclared variable "foo"/);
});
test('jsx undeclared variable', function () {
  // counter example
  var opts = {
    babelrc: false,
    plugins: [_babelPluginTransformReactJsx2.default, _2.default]
  };
  var input = '\n    import React from \'react\';\n    const x = <Foo />;\n  ';
  expect(function () {
    return (0, _babelCore.transform)(input, opts);
  }).toThrow(/Reference to undeclared variable "Foo"/);
});

test('Declared variables', function () {
  var opts = {
    babelrc: false,
    plugins: [_2.default]
  };
  var input = '\n    import Foo from \'./foo\';\n\n    class Bar extends Foo {\n      constructor(props) {\n        super(props);\n      }\n    }\n  ';

  var _transform = (0, _babelCore.transform)(input, opts),
      code = _transform.code;

  expect(code).toMatchSnapshot();
});

test('Declared, transformed variables', function () {
  var opts = {
    babelrc: false,
    plugins: [_babelPluginTransformEs2015Classes2.default, _2.default]
  };
  var input = '\n    import Foo from \'./foo\';\n\n    class Bar extends Foo {\n      constructor(props) {\n        super(props);\n      }\n    }\n  ';

  var _transform2 = (0, _babelCore.transform)(input, opts),
      code = _transform2.code;

  expect(code).toMatchSnapshot();
});

test('Declared, transformed variables', function () {
  var opts = {
    babelrc: false,
    plugins: [_babelPluginTransformEs2015Classes2.default, _2.default]
  };
  var input = '\n    import {Component, Children} from \'react\';\n\n    class Provider extends Component {\n      getChildContext() {\n        return {loginClient: this.client};\n      }\n\n      constructor(props, context) {\n        super(props, context);\n        this.client = props.client;\n      }\n\n      render() {\n        return Children.only(this.props.children);\n      }\n    }\n  ';

  var _transform3 = (0, _babelCore.transform)(input, opts),
      code = _transform3.code;

  expect(code).toMatchSnapshot();
});

test('declared pug variables', function () {
  var opts = {
    babelrc: false,
    plugins: [_babelPluginTransformReactPug2.default, _babelPluginTransformReactJsx2.default, _babelPluginTransformEs2015BlockScoping2.default, _2.default]
  };
  var input = '\n  import React from \'react\';\n  import Col from \'core/col\';\n\n  const MyComponent = React.createClass({\n    render() {\n      const foo = [];\n\n      return pug`\n        div\n          each list, col in foo\n            div(key=col)\n              Col(sm=4)\n                each div in list\n                  div(key=div.id)\n      `;\n    },\n  });\n  ';

  var _transform4 = (0, _babelCore.transform)(input, opts),
      code = _transform4.code;

  expect(code).toMatchSnapshot();
});